<?php
/**********************************************************************************
* Affiliates.php                                                                  *
***********************************************************************************
*                                                                                 *
* SMF Affiliates Mod v3.0.2                                                       *
* Copyright (c) 2009 by NIBOGO. All rights reserved.                              *
* Powered by www.mundo-se.com                                                     *
* Created by NIBOGO for Simplemachines.org                                        *
*                                                                                 *
**********************************************************************************/

function AffiliatesMain()
{
	global $sourcedir, $context, $txt, $boardurl, $boarddir, $scripturl, $smcFunc, $modSettings;	
 	
	// Load the affiliates language
	if (loadlanguage('Affiliates') == false)
		loadLanguage('Affiliates','english');
		
	// Load the Affiliates Template
	loadtemplate('Affiliates');

	// Load all the subactions for the AFFILIATES
	$subActions = array(		
		'add' => 'affiliates_add',
		'addverify' => 'affiliates_add_verify',
		'edit' => 'affiliates_edit',
		'editverify' => 'affiliates_edit_verify',
		'delete' => 'affiliates_delete_verify',		
		'view' => 'affiliates_view',
                'info' => 'affiliates_info',
                'settings' => 'affiliates_admin_settings',
		'approval' => 'affiliates_approval',
		'banners' => 'affiliates_banners',
		'bannersadd' => 'affiliates_banners_add',
		'bannersaddverify' => 'affiliates_banners_add_verify',
		'bannersedit' => 'affiliates_banners_edit',
		'bannerseditverify' => 'affiliates_banners_edit_verify',
		'bannersdelete' => 'affiliates_banners_delete',
		'version' => 'affiliates_version',
		'ok' => 'affiliates_ok',
		'appstuff' => 'affiliates_appstuff',
                'commentverify' => 'add_comment_verify',
		'editcomment' => 'edit_comment',
		'editcommentverify' => 'edit_comment_verify',
		'deletecomment' => 'delete_comment',  
                'stats' => 'affiliates_stats',
                'vote' => 'affiliates_vote',
	);
	
	// Add the Linktree
        $context['linktree'][] = array(		
		'name' => $txt['affiliates_text'],
		'url' => $scripturl.'?action=affiliates',
        );

	if (empty($_REQUEST['sa']) && !empty($_REQUEST['id']))
            affiliates_info();  

        if (empty($_REQUEST['sa']) && empty($_REQUEST['id']))
	    affiliates_main();  

        if (isset($_REQUEST['sa']))
		$sa = $_GET['sa'];
	elseif (!isset($_REQUEST['sa'])) 
		$sa = '';      
		
	if (!empty($subActions[$sa]))
		$subActions[$sa]();
}

function affiliates_main()
{
	global $txt, $context, $smcFunc, $sourcedir, $board_info, $scripturl, $modSettings, $themedir, $sourcedir;	
	
	// Check Permission
	if (!allowedTo('affiliates_view'))
		fatal_lang_error('affiliates_no_permission', false);	
		
	// Load the sub-template and page title
	$context['sub_template']  = 'affiliates_main';
	$context['page_title'] = $txt['affiliates_text'];
	
	// Load the affiliates stuff
	$dbresult = $smcFunc['db_query']('', "
	SELECT 
		a.id_affiliate, a.date, a.author, a.title, a.views, m.real_name, a.description, a.enable, a.image, a.url, a.total_rates
	FROM {db_prefix}affiliates AS a
	LEFT JOIN {db_prefix}members AS m  ON (a.author = m.ID_MEMBER)
	WHERE enable = 1 ");
	
	$context['affiliate'] = array();
	while ($row = $smcFunc['db_fetch_assoc']($dbresult))
	$context['affiliate'][] = $row;
	$smcFunc['db_free_result']($dbresult);
}

function affiliates_add()
{
	global $txt, $context, $smcFunc, $scripturl, $modSettings, $themedir, $sourcedir;	
	
	// Check Permission for Admin and Affiliates Manager
	if (!allowedTo('affiliates_add'))
		fatal_lang_error('affiliates_no_permission', false);	
		
	// Load the sub-template and page title
	$context['sub_template']  = 'affiliates_add';
	$context['page_title'] = $txt['affiliates_add'];

        if (!empty($modSettings['affiliates_verification']) && $context['user']['is_guest']){
	
		require_once($sourcedir . '/Subs-Editor.php');
		$verificationOptions = array(
			'id' => 'register',
		);
		$context['visual_verification'] = create_control_verification($verificationOptions);
		$context['visual_verification_id'] = $verificationOptions['id'];
	}
	// Otherwise we have nothing to show.
	else
		$context['visual_verification'] = false;	
	
        //Add the Linktree
        $context['linktree'][] = array(		
		'name' => $txt['affiliates_add'],
		'url' => $scripturl.'?action=affiliates;sa=add',
        );
}

function affiliates_add_verify()
{
	global $txt, $smcFunc, $user_info, $sourcedir, $context, $modSettings;
	
	// Check Permission for Admin and Affiliates Manager
	if (!allowedTo('affiliates_add'))
		fatal_lang_error('affiliates_no_permission', false);	
		
	// Check all the data
	$affiliatetitle = htmlspecialchars($_REQUEST['affiliatetitle'], ENT_QUOTES);
	$affiliatedescription = htmlspecialchars($_REQUEST['affiliatedescription'], ENT_QUOTES);
	$affiliateenable = (isset($_REQUEST['enable'])) ? (int) $_REQUEST['enable'] : '0';
	$affiliateurl = htmlspecialchars($_REQUEST['affiliateurl'], ENT_QUOTES);
	$affiliateimage = htmlspecialchars($_REQUEST['affiliateimage'], ENT_QUOTES);
	$affiliateemail = htmlspecialchars($_REQUEST['affiliateemail'], ENT_QUOTES);
	
	// Errors!!
	if (empty($affiliatetitle))
		fatal_lang_error('affiliates_no_title',false);	

	if (empty($affiliatedescription))
		fatal_lang_error('affiliates_no_description',false);

        if (empty($affiliateurl))
		fatal_lang_error('affiliates_no_url',false);

        if (empty($affiliateimage))
		fatal_lang_error('affiliates_no_image',false);

        if (empty($affiliateemail))
		fatal_lang_error('affiliates_no_email',false);

        // Check if the visual verification code was entered correctly.
	if (!empty($modSettings['affiliates_verification']) && $context['user']['is_guest'])	{
		require_once($sourcedir . '/Subs-Editor.php');
		$verificationOptions = array(
			'id' => 'register',
		);
		$context['visual_verification'] = create_control_verification($verificationOptions, true);

		if (is_array($context['visual_verification']))
		{
			loadLanguage('Errors');
			foreach ($context['visual_verification'] as $error)
				fatal_error($txt['error_' . $error], false);
		}
	}		
		
	$addDate = time();	
	$smcFunc['db_query']('', "INSERT INTO {db_prefix}affiliates
			(date, enable, author, title, description, url, image, email)
			VALUES ($addDate, '$affiliateenable'," . $user_info['id'] . ", '$affiliatetitle', '$affiliatedescription', '$affiliateurl', '$affiliateimage', '$affiliateemail')");
				
	// Now redirectme :)
	if ($affiliateenable == '1')
	redirectexit('action=affiliates');
	else
	redirectexit('action=affiliates;sa=ok');
}

function affiliates_edit()
{
	global $txt, $context, $smcFunc, $scripturl;	
		
	// We need an ID!!	
	if (empty($_REQUEST['id']))
		fatal_lang_error('affiliate_no_selected', false);	
	
	// Get the ID
	$affiliate_id = (int) $_REQUEST['id'];
	
	// Load a sub-template, title and language	
	$context['sub_template']  = 'affiliates_edit';
	$context['page_title'] = $txt['affiliates_edit'];
	loadLanguage('Admin');	

	// Load the affiliate info 
	$dbresult = $smcFunc['db_query']('', "
	SELECT 
		id_affiliate, enable, title, description, url, image, email, author
	FROM {db_prefix}affiliates
	WHERE id_affiliate = $affiliate_id LIMIT 1");
	$row = $smcFunc['db_fetch_assoc']($dbresult);
	$context['affiliates_edit_info'] = $row;
	$context['affiliates_edit_info']['description'] = html_entity_decode($row['description']);
	
	$smcFunc['db_free_result']($dbresult);
	
	// Check Permissions
	if (($context['user']['id'] !== $context['affiliates_edit_info']['author']) && (!allowedTo('edit_affiliates')) && (!allowedTo('affiliates_manage')))
		fatal_lang_error('affiliates_no_permission', false);	
		
        //Add the Linktree       
        $context['linktree'][] = array(
		'url' => $scripturl.'?action=affiliates;id=' . $affiliate_id,
		'name' => $context['affiliates_edit_info']['title'],
	);			
        $context['linktree'][] = array(
		'url' => $scripturl.'?action=affiliates;sa=edit;id=' . $affiliate_id,
		'name' => $txt['affiliates_edit'],
	);		
}

function affiliates_edit_verify()
{
	global $txt, $smcFunc, $sourcedir;
	
	// Check Permission for Admin and Affiliates Manager
	if (!allowedTo('affiliates_manage') && !allowedTo('edit_affiliates'))
		fatal_lang_error('affiliates_no_permission', false);	

	// We need an ID!!	  
	if (empty($_REQUEST['id']))
		fatal_lang_error('affiliates_no_selected', false);	
		
	// Get all the info
	$affiliate_id = (int) $_REQUEST['id'];
	$affiliatetitle = htmlspecialchars($_REQUEST['affiliatetitle'], ENT_QUOTES);
	$affiliatedescription = htmlspecialchars($_REQUEST['affiliatedescription'], ENT_QUOTES);
	$affiliateenable = (isset($_REQUEST['enable'])) ? (int) $_REQUEST['enable'] : '0';
	$affiliateurl = htmlspecialchars($_REQUEST['affiliateurl'], ENT_QUOTES);
	$affiliateimage = htmlspecialchars($_REQUEST['affiliateimage'], ENT_QUOTES);
	$affiliateemail = htmlspecialchars($_REQUEST['affiliateemail'], ENT_QUOTES);
	
	// ERRORS!
        if (empty($affiliatetitle))
		fatal_lang_error('affiliates_no_title',false);	

	if (empty($affiliatedescription))
		fatal_lang_error('affiliates_no_description',false);

        if (empty($affiliateurl))
		fatal_lang_error('affiliates_no_url',false);

        if (empty($affiliateimage))
		fatal_lang_error('affiliates_no_image',false);

        if (empty($affiliateemail))
		fatal_lang_error('affiliates_no_email',false);	
	
	$smcFunc['db_query']('', "
	UPDATE {db_prefix}affiliates
	SET title = '$affiliatetitle', enable = '$affiliateenable',description = '$affiliatedescription', url = '$affiliateurl', image = '$affiliateimage', email = '$affiliateemail'
	WHERE id_affiliate = $affiliate_id LIMIT 1");
				
	// Please redirectme to the affiliates page
	redirectexit('action=affiliates');
}

function affiliates_delete_verify()
{
	global $txt, $smcFunc, $context;
	
	// We need an ID!!	
	if (empty($_REQUEST['id']))
		fatal_lang_error('affiliates_no_selected', false);	
	
	// Get the id
	$affiliate_id = (int) $_REQUEST['id'];
	
	// Load the affiliate info 
	$dbresult = $smcFunc['db_query']('', "
	SELECT 
		id_affiliate, author
	FROM {db_prefix}affiliates
	WHERE id_affiliate = $affiliate_id 
	LIMIT 1");
	$row = $smcFunc['db_fetch_assoc']($dbresult);
	$context['affiliates_delete_info'] = $row;
	
	$smcFunc['db_free_result']($dbresult);
	
	// You can't be here
	if (!allowedTo('affiliates_manage') && !allowedTo('delete_affiliates') && ($context['user']['id'] !== $context['affiliates_edit_info']['author']))
		fatal_lang_error('affiliates_no_delete', false);
	
	// Delete the affiliate info of the DB
	$smcFunc['db_query']('', "
	DELETE FROM {db_prefix}affiliates  
	WHERE id_affiliate = $affiliate_id LIMIT 1");
		
	// Please redirectme to the admin panel
	redirectexit('action=affiliates');
}

function affiliates_view()
{
     global $context, $smcFunc;
		
        // Get the id
	$affiliate_id = (int) $_REQUEST['id'];
	
	if (empty($_REQUEST['id']))
	    fatal_lang_error('affiliates_no_selected', false);
		
	if (!allowedTo('affiliates_view'))
		fatal_lang_error('affiliates_no_permission', false);

	// +1 view
	$smcFunc['db_query']('', "
	UPDATE {db_prefix}affiliates 
	SET views = views + 1
	WHERE id_affiliate = $affiliate_id LIMIT 1");	
	
	// Load the URL
	$dbresult = $smcFunc['db_query']('', "
	SELECT 
		id_affiliate, url
	FROM {db_prefix}affiliates	
	WHERE id_affiliate = $affiliate_id LIMIT 1");
	
	$row = $smcFunc['db_fetch_assoc']($dbresult);
	$smcFunc['db_free_result']($dbresult);
	
	// Now redirectme!
	header("Location: ".$row['url']);
	exit;
}

function affiliates_info()
{
        global $context, $smcFunc, $txt, $sourcedir, $scripturl;
		
        // Get the id
	$affiliate_id = (int) $_REQUEST['id'];
	
	if (empty($_REQUEST['id']))
	    fatal_lang_error('affiliates_no_selected', false);
		
	if (!allowedTo('affiliates_view'))
		fatal_lang_error('affiliates_no_permission', false);

	// Load the Info
	$dbresult = $smcFunc['db_query']('', "
	SELECT 
		a.id_affiliate, a.url, a.comment_total, a.author, a.description, a.views, a.image, a.title, a.date, m.real_name, a.total_rates
	FROM {db_prefix}affiliates as a
        LEFT JOIN {db_prefix}members AS m ON (a.author = m.id_member)
	WHERE id_affiliate = $affiliate_id LIMIT 1");
	
	$affiliate = array();

	while ($row = $smcFunc['db_fetch_assoc']($dbresult)){
		$affiliate = array(
			'title' => $row['title'],
                        'url' => $row['url'],
                        'comment_total' => $row['comment_total'],
			'id_affiliate' => $row['id_affiliate'],
			'date' => timeformat($row['date']),
		        'author' => '<a href="'.$scripturl.'?action=profile;u='.$row['author'].'">'.$row['real_name'].'</a>',
                        'views' => $row['views'],
                        'description' => $row['description'],
			'image' => $row['image'],
                        'total_rates' => $row['total_rates'],		
		);
	}
	$smcFunc['db_free_result']($dbresult);	
	$context['affiliate'] = $affiliate;

        // Load all the comments
	$dbresult2 = $smcFunc['db_query']('', '
	SELECT
		ac.id_affiliate,  ac.id_comment, ac.date, ac.comment, ac.author,
		ac.last_modified, ac.modified_name, m.real_name
		FROM {db_prefix}affiliates_comments as ac
		   LEFT JOIN {db_prefix}members AS m ON (ac.author = m.id_member)
		WHERE ac.id_affiliate = {int:affiliate_id}        
        ORDER BY ac.id_comment',
        array(
          'affiliate_id' => $affiliate_id,
        )
        );

	$context['affiliate_comment'] = array();	
	while ($row2 = $smcFunc['db_fetch_assoc']($dbresult2))
        $context['affiliate_comment'][] = $row2;
	$smcFunc['db_free_result']($dbresult2);		
	$context['comment_count'] =  $smcFunc['db_affected_rows']();	
	
	// Needed for the WYSIWYG editor.
	require_once($sourcedir . '/Subs-Editor.php');

	// Now create the editor.
	$editorOptions = array(
		'id' => 'message',
		'value' => '',
		'width' => '90%',
		'form' => 'addcomment',
		'labels' => array(
			'addcomment' => $txt['affiliates_add_comment']
		),
	);
	create_control_richedit($editorOptions);
	$context['post_box_name'] = $editorOptions['id'];	
	
	// This generate the captcha  only if the option is enable and the user is guest
	if (!empty($modSettings['affiliates_verification']) && $context['user']['is_guest']){
	
		require_once($sourcedir . '/Subs-Editor.php');
		$verificationOptions = array(
			'id' => 'register',
		);
		$context['visual_verification'] = create_control_verification($verificationOptions);
		$context['visual_verification_id'] = $verificationOptions['id'];
	}
	// Otherwise we have nothing to show.
	else
		$context['visual_verification'] = false;
	

        // Load the sub-template and page title
	$context['sub_template']  = 'affiliates_info';
	$context['page_title'] = $context['affiliate']['title']; 	

}

function affiliates_banners()
{
    global $txt, $context, $smcFunc, $sourcedir, $board_info, $scripturl, $modSettings, $themedir, $sourcedir;	
	
	// Check Permission
	if (!allowedTo('affiliates_view'))
		fatal_lang_error('affiliates_no_permission', false);	
		
	// Load the sub-template and page title
	$context['sub_template']  = 'affiliates_banners';
	$context['page_title'] = $txt['affiliates_admin_banners'];
	
	// Load the banners stuff
	$dbresult = $smcFunc['db_query']('', "
	SELECT 
		id_banner, image
	FROM {db_prefix}affiliates_banners");
	
	$context['banner'] = array();
	while ($row = $smcFunc['db_fetch_assoc']($dbresult))
	$context['banner'][] = $row;
	$smcFunc['db_free_result']($dbresult);
	
	//Add the Linktree	
        $context['linktree'][] = array(		
		'name' => $txt['affiliates_admin_banners'],
		'url' => $scripturl.'?action=affiliates;sa=banners',
        );	
}

function affiliates_banners_add()
{
	global $txt, $context, $smcFunc, $scripturl, $modSettings, $themedir, $sourcedir;	
	
	// Tabs for browsing the different Affiliates admin panel
	$context[$context['admin_menu_name']]['tab_data']['title'] = $txt['affiliates_admin_add_banner'];
	$context[$context['admin_menu_name']]['tab_data']['description'] = $txt['affiliates_bannersadd_description'];

	// Check Permission for Admin and Affiliates Manager
	if (!allowedTo('affiliates_manage'))
		fatal_lang_error('affiliates_no_permission', false);	
		
	// Load the sub-template and page title
	$context['sub_template']  = 'affiliates_banners_add';
	$context['page_title'] = $txt['affiliates_admin_add_banner'];	
	
        //Add the Linktree
	$context['linktree'][] = array(		
		'name' => $txt['affiliates_admin'],
		'url' => $scripturl.'?action=admin;area=affiliates;sa=setting',
        );
	$context['linktree'][] = array(		
		'name' => $txt['affiliates_admin_add_banner'],
		'url' => $scripturl.'?action=admin;area=affiliates;sa=bannersadd',
        );
}

function affiliates_banners_add_verify()
{
	global $txt, $smcFunc, $sourcedir, $context;
	
	// Check Permission for Admin and Affiliates Manager
	if (!allowedTo('affiliates_manage'))
		fatal_lang_error('affiliates_no_permission', false);	
		
	// Check the banner image
	$bannerimage = htmlspecialchars($_REQUEST['bannerimage'], ENT_QUOTES);

	if (empty($bannerimage))
		fatal_lang_error('banner_no_image',false);	

	$smcFunc['db_query']('', "INSERT INTO {db_prefix}affiliates_banners
			(image)
			VALUES ('$bannerimage')");
				
	// Please redirectme to the admin panel
	redirectexit('action=affiliates;sa=banners');
}

function affiliates_banners_edit()
{
	global $txt, $context, $smcFunc, $scripturl, $mbname;	
		
	// We need an ID!!	
	if (empty($_REQUEST['id']))
		fatal_lang_error('banner_no_selected', false);	

        // Check Permission for Admin and Affiliates Manager
	if (!allowedTo('affiliates_manage'))
		fatal_lang_error('affiliates_no_permission', false);	
	
	// Get the ID
	$banner_id = (int) $_REQUEST['id'];
	
	// Load a sub-template, title and language	
	$context['sub_template']  = 'banners_edit';
        $context['page_title'] = $mbname . ' - ' . $txt['banners_edit']; 
	loadLanguage('Admin');	

	// Load the banner info 
	$dbresult = $smcFunc['db_query']('', "
	SELECT 
		id_banner, image
	FROM {db_prefix}affiliates_banners
	WHERE id_banner = $banner_id LIMIT 1");
	$row = $smcFunc['db_fetch_assoc']($dbresult);
	$context['banners_edit_info'] = $row;	
	$smcFunc['db_free_result']($dbresult);
	
}

function affiliates_banners_edit_verify()
{
	global $txt, $smcFunc, $sourcedir, $board_info, $board, $selected_boards;
	
	// Check Permission for Admin and Affiliates Manager
	if (!allowedTo('affiliates_manage'))
		fatal_lang_error('affiliates_no_permission', false);	

	// We need an ID!!	  
	if (empty($_REQUEST['id']))
		fatal_lang_error('banners_no_selected', false);	
		
	// Check the banner
	$bannerimage = htmlspecialchars($_REQUEST['bannerimage'], ENT_QUOTES);
        $banner_id = $_REQUEST['id'];
	
        if (empty($bannerimage))
		fatal_lang_error('banner_no_image',false);    
	
	$smcFunc['db_query']('', "
	UPDATE {db_prefix}affiliates_banners
	SET image = '$bannerimage'
	WHERE id_banner = $banner_id LIMIT 1");
				
	// Please redirectme to the new banner
	redirectexit('action=affiliates;sa=banners');
}

function affiliates_banners_delete()
{
	global $txt, $smcFunc, $context;
	
	// You can`t be here
	if (!allowedTo('affiliates_manage'))
		fatal_lang_error('affiliates_no_delete', false);
		
	// We need an ID!!	
	if (empty($_REQUEST['id']))
		fatal_lang_error('banner_no_selected', false);	
	
	// Get the id
	$banner_id = (int) $_REQUEST['id'];
	
	// Delete the banner info of the DB
	$smcFunc['db_query']('', "
	DELETE FROM {db_prefix}affiliates_banners
	WHERE id_banner = $banner_id LIMIT 1");
		
	// Please redirectme to the admin panel
	redirectexit('action=affiliates;sa=banners');
}

function affiliates_approval()
{
    global $txt, $context, $smcFunc, $sourcedir, $board_info, $scripturl, $modSettings, $themedir, $sourcedir;	
	
	// Tabs for browsing the different Affiliates admin panel
	$context[$context['admin_menu_name']]['tab_data']['title'] = $txt['affiliates_admin_approval'];
	$context[$context['admin_menu_name']]['tab_data']['description'] = $txt['affiliates_approval_description'];

        // Check Permission
	if (!allowedTo('affiliates_manage'))
		fatal_lang_error('affiliates_no_permission', false);	
		
	// Load the sub-template and page title
	$context['sub_template']  = 'affiliates_approval';
	$context['page_title'] = $txt['affiliates_admin_approval'];
	
	// Load the banners stuff
	$dbresult = $smcFunc['db_query']('', "
	SELECT 
		a.id_affiliate, a.title, a.description, a.image, a.enable, a.date, a.author, m.real_name, a.email
	FROM {db_prefix}affiliates AS a
	LEFT JOIN {db_prefix}members AS m  ON (a.author = m.ID_MEMBER)
	WHERE enable = 0 ");
	
	$context['affiliate'] = array();
	while ($row = $smcFunc['db_fetch_assoc']($dbresult))
	$context['affiliate'][] = $row;
	$smcFunc['db_free_result']($dbresult);
	
	//Add the Linktree
	$context['linktree'][] = array(		
		'name' => $txt['affiliates_admin'],
		'url' => $scripturl.'?action=admin;area=affiliates;sa=settings',
        );
        $context['linktree'][] = array(		
		'name' => $txt['affiliates_admin_approval'],
		'url' => $scripturl.'?action=admin;area=affiliates;sa=approval',
        );	
}

function affiliates_bar()
{
    global $txt, $scripturl, $settings;	
	 
        // This is the main bar in the top of all the mod
	echo'<div class="titlebg" style="height: 25px;"><a href="'.$scripturl.'?action=affiliates" align="middle" title="'.$txt['affiliates_text'].'"><img src="'.$settings['theme_url'].'/images/affiliates/affiliates.png" alt="'.$txt['affiliates_text'].'"> '.$txt['affiliates_text'].'</a>
	', (allowedTo('affiliates_view')) ? '- <a href="'.$scripturl.'?action=affiliates;sa=banners" align="middle" title="'.$txt['affiliates_link_us'].'"><img src="'.$settings['theme_url'].'/images/affiliates/link.png" alt="'.$txt['affiliates_link_us'].'"> '.$txt['affiliates_link_us'].'</a>' : '', '	
	', (allowedTo('affiliates_manage')) ? '- <a href="'.$scripturl.'?action=admin;area=affiliates;sa=bannersadd" align="middle" title="'.$txt['affiliates_add_banner'].'"><img src="'.$settings['theme_url'].'/images/affiliates/banner.png" alt="'.$txt['affiliates_add_banner'].'"> '.$txt['affiliates_add_banner'].'</a>' : '', '	
	', (allowedTo('affiliates_add')) ? '- <a href="'.$scripturl.'?action=affiliates;sa=add" align="middle" title="'.$txt['affiliates_add'].'"><img src="'.$settings['theme_url'].'/images/affiliates/add.png" alt="'.$txt['affiliates_add'].'"> '.$txt['affiliates_add'].'</a>' : '', '
	', (allowedTo('affiliates_manage')) ? '- <a href="'.$scripturl.'?action=admin;area=affiliates;sa=approval" align="middle" title="'.$txt['affiliates_awaiting_approval'].'"><img src="'.$settings['theme_url'].'/images/affiliates/approval.png" alt="'.$txt['affiliates_awaiting_approval'].'"> '.$txt['affiliates_awaiting_approval'].'</a> - <a href="'.$scripturl.'?action=admin;area=affiliates;sa=settings" align="middle" title="'.$txt['affiliates_admin'].'"><img src="'.$settings['theme_url'].'/images/affiliates/settings.png" alt="'.$txt['affiliates_admin'].'"> '.$txt['affiliates_admin'].'</a>' : '', '
       - <a href="'.$scripturl.'?action=affiliates;sa=stats" align="middle" title="'.$txt['affiliates_stats'].'"><img src="'.$settings['theme_url'].'/images/affiliates/stats.png" alt="'.$txt['affiliates_stats'].'"> '.$txt['affiliates_stats'].'</a>
   </div>';
}

function affiliates_admin_settings($return_config = false)
{    
	global $txt, $scripturl, $context, $sourcedir, $modSettings, $db_prefix;
	
	$context[$context['admin_menu_name']]['tab_data']['title'] = $txt['affiliates_admin_settings'];
	$context[$context['admin_menu_name']]['tab_data']['description'] = $txt['affiliates_admin_settings_description'];
	
	// You aren't admin?? Please you can`t be here
	if (!allowedTo('affiliates_manage'))
	    fatal_lang_error('affiliates_no_permission', false);
	
        require_once($sourcedir . '/ManageServer.php');

        // Load the template and title
        $context['sub_template'] = 'show_settings';
        $context['page_title'] = $txt['affiliates_settings'];

	// We need this 
	require_once($sourcedir.'/ManageServer.php');
	
	$config_vars = array(
        $txt['affiliates_settings'],	
	        array('large_text', 'affiliates_admin_requeriments', 'subtext' => $txt['affiliates_admin_requeriments2'], 'size' => 15),
	        array('check', 'affiliates_admin_views', 'subtext' => $txt['affiliates_admin_views2']),
		array('check', 'affiliates_admin_submitted', 'subtext' => $txt['affiliates_admin_submitted2']),
		array('check', 'affiliates_admin_submitted_date', 'subtext' => $txt['affiliates_admin_submitted_date2']),
                array('check', 'affiliates_admin_rate', 'subtext' => $txt['affiliates_admin_rate2']),
                array('check', 'affiliates_pr', 'subtext' => $txt['affiliates_admin_pr2']),
                array('check', 'affiliates_verification', 'subtext' => $txt['affiliates_verification2']),  
       $txt['affiliates_on_board'],
		array('check', 'affiliates_admin_index', 'subtext' => $txt['affiliates_admin_index2']),
		array('check', 'affiliates_marquee', 'subtext' => $txt['affiliates_admin_marquee2']),
                array('select', 'affiliates_marquee_dir', array('right' => $txt['affiliates_right'], 'left' => $txt['affiliates_left']),'subtext' => $txt['affiliates_admin_marquee_dir2']),
		array('check', 'affiliates_stop', 'subtext' => $txt['affiliates_admin_stop2']),                
	);

		
	if (isset($_GET['save']))
	{
		saveDBSettings($config_vars);
		redirectexit('action=admin;area=affiliates;sa=settings');
	}
	$context['post_url'] = $scripturl .'?action=admin;area=affiliates;sa=settings;save';	
	prepareDBSettingContext($config_vars);		
	
	//Add the Linktree   
        $context['linktree'][] = array(		
		'name' => $txt['affiliates_admin'],
		'url' => $scripturl.'?action=admin;area=affiliates;sa=settings',
         );
}

function affiliates_version()
{
	global $context, $txt, $scripturl;	
	
	// Tabs for browsing the different Affiliates admin panel
	$context[$context['admin_menu_name']]['tab_data']['title'] = $txt['affiliates_version'];
	$context[$context['admin_menu_name']]['tab_data']['description'] = $txt['affiliates_version_description'];

	// You aren't admin?? Please you can`t be here
	if (!allowedTo('affiliates_manage'))
	    fatal_lang_error('affiliates_no_permission', false);
	
	$context['page_title'] = $txt['affiliates_version'];
	$context['sub_template'] = 'affiliates_version';	
	
	//Add the Linktree   
        $context['linktree'][] = array(		
		'name' => $txt['affiliates_admin'],
		'url' => $scripturl.'?action=admin;area=affiliates;sa=settings',
        );
	$context['linktree'][] = array(		
		'name' => $txt['affiliates_version'],
		'url' => $scripturl.'?action=admin;area=affiliates;sa=version',
        );
}

function affiliates_ok()
{
	global $context, $txt, $scripturl;	
	
	$context['page_title'] = $txt['affiliates_ok'];
	$context['sub_template'] = 'affiliates_ok';	
	
	//Add the Linktree   
        $context['linktree'][] = array(		
		'name' => $txt['affiliates_text'],
		'url' => $scripturl.'?action=affiliates',
        );
	$context['linktree'][] = array(		
		'name' => $txt['affiliates_add'],
		'url' => $scripturl.'?action=affiliates;sa=add',
        );
}

function affiliates_appstuff()
{
	global $context, $scripturl, $smcFunc, $txt;
	
	// You aren't admin?? Please you can't be here
	if (!allowedTo('affiliates_manage'))
	     fatal_lang_error('affiliates_no_permission', false);
	
        // Get the id and load the affiliate
        $affiliate_id = (int) $_REQUEST['id'];
	
	$dbresult = $smcFunc['db_query']('', '
	SELECT 
		id_affiliate, enable
	FROM {db_prefix}affiliates
	WHERE id_affiliate = {int:affiliate_id}
	LIMIT 1',
	array(
        'affiliate_id' => $affiliate_id,
        ));	
	
	if ($smcFunc['db_num_rows']($dbresult) == 0)
		fatal_lang_error('affiliates_not_exist', false);
	
	$row = $smcFunc['db_fetch_assoc']($dbresult);
	$smcFunc['db_free_result']($dbresult);

	// Disable if currently is enable
	if ($row['enable'] == '1')
	{
        $dbresult = $smcFunc['db_query']('', '
	UPDATE {db_prefix}affiliates
	SET enable = 0
        WHERE id_affiliate = {int:affiliate_id}
	LIMIT 1',
	array(
        'affiliate_id' => $affiliate_id,
        ));	
	}
	//Enable if currently is enable
        else
        {
	$dbresult = $smcFunc['db_query']('', '
	UPDATE {db_prefix}affiliates
	SET enable = 1
        WHERE id_affiliate = {int:affiliate_id}
	LIMIT 1',
	array(
        'affiliate_id' => $affiliate_id,
        ));
        }	

        // Redirect me :)
	redirectexit('action=affiliates');
}

function add_comment_verify()
{
	global $context, $scripturl, $txt, $sourcedir, $modSettings, $smcFunc, $user_info, $user_profile;

	// We love WYSIWYG Editor
	if (!empty($_REQUEST['message_mode']) && isset($_REQUEST['message']))
	{
		require_once($sourcedir . '/Subs-Editor.php');
		$_REQUEST['message'] = html_to_bbc($_REQUEST['message']);
		$_REQUEST['message'] = un_htmlspecialchars($_REQUEST['message']);
	}	

	$commentbody = htmlspecialchars($_REQUEST['message'],ENT_QUOTES);	
	$affiliate_id = (int) $_REQUEST['id'];

        // Show me the errors!!
	if (!isset($affiliate_id))
		fatal_lang_error('affiliate_no_selected', false);
	
        if (!allowedTo('affiliates_comment'))
	    fatal_lang_error('affiliates_no_comment', false);	
		
	// Check if the visual verification code was entered correctly.
	if (!empty($modSettings['affiliates_verification']) && $context['user']['is_guest'])	{
		require_once($sourcedir . '/Subs-Editor.php');
		$verificationOptions = array(
			'id' => 'register',
		);
		$context['visual_verification'] = create_control_verification($verificationOptions, true);

		if (is_array($context['visual_verification']))
		{
			loadLanguage('Errors');
			foreach ($context['visual_verification'] as $error)
				fatal_error($txt['error_' . $error], false);
		}
	}	

	// Load all the global announcement info	 
        $dbresult = $smcFunc['db_query']('', '
        SELECT
    	   a.id_affiliate, ac.author, a.comment_total
        FROM {db_prefix}affiliates AS a
        LEFT JOIN {db_prefix}affiliates_comments AS ac ON (ac.id_affiliate  = a.id_affiliate)
        WHERE a.id_affiliate = {int:affiliate_id} 
	LIMIT 1',
	array(
          'affiliate_id' => $affiliate_id,
             )
        );	
	
	$row = $smcFunc['db_fetch_assoc']($dbresult);
	$context['affiliate'][] = $row;
	$smcFunc['db_free_result']($dbresult);
	$comment_total = $row['comment_total'];

        // We need a commentbody
	if (empty($commentbody))
		fatal_lang_error('affiliates_no_commentbody',false);

	//  Define the comment creation time	
	$add_date = time();	

	// Add all the info to the DB
	$smcFunc['db_insert']('replace',
			'{db_prefix}affiliates_comments',
			array(
				'id_affiliate' => 'int', 'author' => 'int', 'comment' => 'text', 'date' => 'int',
			),
			array(
				$affiliate_id, $user_info['id'], $commentbody, $add_date,
			),
			array('id_affiliate', 'author', 'comment', 'date')
	);	
		
	$comment_id = $smcFunc['db_insert_id']('{db_prefix}affiliates_comments', 'id_comment');
		
	// +1 Comment
	$dbresult = $smcFunc['db_query']('', "
	UPDATE {db_prefix}affiliates
        SET comment_total = '$comment_total' + 1
	WHERE id_affiliate = {int:affiliate_id} 
	LIMIT 1",
	array(
             'affiliate_id' => $affiliate_id,
        )
        );
	
	redirectexit('action=affiliates;sa=info;id=' . $_REQUEST['id']);
}

function edit_comment()
{
	global $context, $txt, $sourcedir, $modSettings, $user_info, $smcFunc, $scripturl;	

	$comment_id = (int) $_REQUEST['id'];
	
	if (!isset($comment_id))
		fatal_lang_error('affiliates_no_selected_comment', false);

        $dbresult = $smcFunc['db_query']('', "
        SELECT
    	    id_comment, id_affiliate, author, comment, date, last_modified
        FROM {db_prefix}affiliates_comments
        WHERE id_comment = {int:comment_id} 
	LIMIT 1",
	array(
          'comment_id' => $comment_id,
        )
        );	
	$row = $smcFunc['db_fetch_assoc']($dbresult);
	$context['affiliate_comment'][] = $row;
	$smcFunc['db_free_result']($dbresult);
	
	$comment_body = $row['comment'];
	$id_comment = $row['id_comment'];
	
	if ((!allowedTo('affiliates_manage') || !allowedTo('affiliates_comment')) && $context['affiliate_comment']['author'] !== $user_info['id'])
	    fatal_lang_error('affiliates_no_permission', false);	
		 
	// Load the sub-template and page title
	$context['sub_template']  = 'edit_comment';
	$context['page_title'] = $txt['affiliates_edit_comment'];

	// We love WYSIWYG
	require_once($sourcedir . '/Subs-Editor.php');

	$editorOptions = array(
		'id' => 'message',
		'value' => $comment_body,
		'width' => '90%',
		'form' => 'editcomment',
		'labels' => array(
			'post_button' => $txt['affiliates_edit_comment']
		),
	);
	create_control_richedit($editorOptions);
	$context['post_box_name'] = $editorOptions['id'];

        $affiliate = $row['id_affiliate'];

        // The Linktree       
	$context['linktree'][] = array(
		'url' => $scripturl.'?action=affiliates;sa=info;id=' . $affiliate,
		'name' => $txt['affiliates_editing_comment'],
	); 	
}

function edit_comment_verify()
{
	global $context, $txt, $scripturl, $smcFunc, $sourcedir, $user_info;
	
	//  We love WYSIWYG Editor
	if (!empty($_REQUEST['message_mode']) && isset($_REQUEST['message']))
	{
		require_once($sourcedir . '/Subs-Editor.php');
		$_REQUEST['message'] = html_to_bbc($_REQUEST['message']);
		$_REQUEST['message'] = un_htmlspecialchars($_REQUEST['message']);
	}

	$comment_id = (int) $_REQUEST['id'];
	
	if (!isset($comment_id))
	    fatal_lang_error('affiliates_no_selected_comment', false);

	// Load all the announcement stuff
        $dbresult = $smcFunc['db_query']('', '
        SELECT
    	id_comment, id_affiliate, author
           FROM {db_prefix}affiliates_comments
	WHERE id_comment = {int:comment_id} 
	LIMIT 1',
	array(
          'comment_id' => $comment_id,
        )
        );   
	$row = $smcFunc['db_fetch_assoc']($dbresult);
	$smcFunc['db_free_result']($dbresult);	
	$affiliate = $row['id_affiliate'];
	$id_comment = $row['id_comment'];

	// You can`t be here 
	if (($context['affiliate_comment']['author'] !== $user_info['id'] && !allowedTo('affiliates_comment')) || !allowedTo('affiliates_manage'))
	    fatal_lang_error('affiliates_no_selected_comment', false);
	
        $commentbody = htmlspecialchars($_REQUEST['message'],ENT_QUOTES);
		
	if (empty($commentbody))
		fatal_lang_error('affiliates_no_commentbody',false);

	$modified_time = time();
	$modified_name = $user_info['name'];

	// Update the comment
        $dbresult = $smcFunc['db_query']('', "
	UPDATE {db_prefix}affiliates_comments
        SET comment = '$commentbody', last_modified = '$modified_time', modified_name = '$modified_name'
	WHERE id_comment = {int:comment_id} 
	LIMIT 1",
	    array(
            'comment_id' => $comment_id,
        ));	
    
        // Redirect Me
        redirectexit('action=affiliates;sa=info;id=' . $affiliate);	
}

function delete_comment()
{
	global $context, $txt, $scripturl, $modSettings, $smcFunc, $user_info;

	$comment_id = (int) $_REQUEST['id'];
	
	if (!isset($comment_id))
		fatal_lang_error('affiliates_no_selected_comment' , false);

	// Load the comment info
	$dbresult = $smcFunc['db_query']('', '
	SELECT
		id_affiliate ,id_comment,author
	FROM {db_prefix}affiliates_comments
	WHERE id_comment = {int:comment_id} 
	    LIMIT 1',
	    array(
            'comment_id' => $comment_id,
        ));	
	
	$row = $smcFunc['db_fetch_assoc']($dbresult);
	$context['affiliate']['comment'][] = $row;
	$smcFunc['db_free_result']($dbresult);
	$affiliate = $row['id_affiliate'];
	
	if (!allowedTo('affiliates_manage') || !allowedTo('affiliates_comment') && $context['affiliate']['comment']['author'] !== $user_info['id'])
	   fatal_lang_error('affiliates_no_permission', false);

	// DELETE!!
	$smcFunc['db_query']('', '
	DELETE FROM {db_prefix}affiliates_comments
        WHERE id_comment = {int:comment_id} 
	    LIMIT 1',
	    array(
            'comment_id' => $comment_id,
        ));

	// Update the Affiliate
	$dbresult = $smcFunc['db_query']('', '
	UPDATE {db_prefix}affiliates
        SET comment_total = comment_total - 1
        WHERE id_affiliate = {int:affiliate_id} 
	LIMIT 1',
	array(
        'affiliate_id' => $affiliate,
        ));
	
	redirectexit('action=affiliates;sa=info;id=' . $affiliate);
}

function affiliates_vote()
{
	global $context, $txt, $scripturl, $modSettings, $smcFunc, $user_info;

	$affiliate = (int) $_REQUEST['id'];
	
	if (!isset($affiliate))
		fatal_lang_error('affiliates_no_selected_comment' , false);

        $dbrequest = $smcFunc['db_query']('', '
	SELECT 
		COUNT(*) AS total 
	FROM {db_prefix}affiliates_rating
	WHERE id_affiliate = {int:affiliate} AND id_member = {int:member} ',
	    array(
            'affiliate' => $affiliate,
            'member' => $user_info['id'], 
        ));

	$totalrow = $smcFunc['db_fetch_assoc']($dbrequest);
	$totalvotes = $totalrow['total'];
	$smcFunc['db_free_result']($dbrequest);		
			
        // Maybe we rate this in the past!
        if ($totalvotes !== '0') 
            fatal_lang_error('affiliates_no_rate', false); 
			
	if (!allowedTo('affiliates_rate'))
	   fatal_lang_error('affiliates_no_permission', false);

        // Define if we want +1 or -1
        if ($_REQUEST['type'] == 'up'){
           $value = 1;
             
	$dbresult = $smcFunc['db_query']('', '
	UPDATE {db_prefix}affiliates
        SET total_rates = total_rates + 1
        WHERE id_affiliate = {int:affiliate} 
	LIMIT 1',
	array(
        'affiliate' => $affiliate,
        ));
 
        } 
        else{
           $value = 0;

	$dbresult = $smcFunc['db_query']('', '
	UPDATE {db_prefix}affiliates
        SET total_rates = total_rates - 1
        WHERE id_affiliate = {int:affiliate} 
	LIMIT 1',
	array(
        'affiliate' => $affiliate,
        ));   
        }   

        // Add all the info to the DB
	$smcFunc['db_insert']('replace',
			'{db_prefix}affiliates_rating',
			array(
				'id_affiliate' => 'int', 'id_member' => 'int', 'value' => 'int',
			),
			array(
				$affiliate, $user_info['id'], $value,
			),
			array('id_affiliate', 'id_member', 'value')
	); 
	
	redirectexit('action=affiliates;sa=info;id=' . $affiliate);
}

function affiliates_stats()
{
	global $context, $mbname, $txt, $context, $scripturl, $smcFunc;
	
	// You aren't admin?? Please you can`t be here
	if (!allowedTo('affiliates_view'))
	    fatal_lang_error('affiliates_no_permission', false);
	
	// Get the total of affiliates, views, rates and comments
	$dbrequest = $smcFunc['db_query']('', '
	SELECT 
		COUNT(*) AS total 
	FROM {db_prefix}affiliates
	WHERE enable = {int:is_enable}',
	    array(
            'is_enable' => '1',
        ));

	$totalrow = $smcFunc['db_fetch_assoc']($dbrequest);
	$context['total_affiliates'] = $totalrow['total'];
	$smcFunc['db_free_result']($dbrequest);	

        $result = $smcFunc['db_query']('', "
	SELECT
		SUM(views) AS views, SUM(comment_total) AS comment_total, SUM(total_rates) AS total_rates,
	 	COUNT(*) AS filetotal
	FROM {db_prefix}affiliates");
	$row = $smcFunc['db_fetch_assoc']($result);
	$smcFunc['db_free_result']($result);

	$context['total_rates'] = $row['total_rates'];
	$context['total_views'] = $row['views'];
	$context['total_comments'] = $row['comment_total'];

        // Top Viewed Affiliates
	$result = $smcFunc['db_query']('', "
	SELECT
		id_affiliate, title, views
	FROM {db_prefix}affiliates
	WHERE enable = 1 AND views > 0
	ORDER BY views DESC LIMIT 10");
	$context['top_viewed'] = array();
	$max_views = 1;
	while ($row = $smcFunc['db_fetch_assoc']($result))
	{
		$context['top_viewed'][] = array(
			'id_affiliate' => $row['id_affiliate'],
			'views' => $row['views'],
			'link' => '<a href="' . $scripturl . '?action=affiliates;sa=info;id=' . $row['id_affiliate'] . '">' . $row['title'] . '</a>',
		);

		if ($max_views < $row['views'])
			$max_views = $row['views'];
	}
	$smcFunc['db_free_result']($result);

	foreach ($context['top_viewed'] as $i => $file)
		$context['top_viewed'][$i]['percent'] = round(($file['views'] * 100) / $max_views);

        // Top Rated
	$result = $smcFunc['db_query']('', "
	SELECT
		id_affiliate, title, total_rates
	FROM {db_prefix}affiliates
	WHERE enable = 1 AND total_rates > 0
	ORDER BY total_rates DESC LIMIT 10");
	$context['top_rating'] = array();
	$max_rating = 1;
	while ($row = $smcFunc['db_fetch_assoc']($result))
	{
		$context['top_rating'][] = array(			
			'title' => $row['title'],
			'total_rates' => $row['total_rates'],
			'link' => '<a href="' . $scripturl . '?action=affiliates;sa=info;id=' . $row['id_affiliate'] . '">' . $row['title'] . '</a>',
		);

		if ($max_rating < $row['total_rates'])
			$max_rating = $row['total_rates'];
	}
	$smcFunc['db_free_result']($result);

	foreach ($context['top_rating'] as $i => $affiliate)
		$context['top_rating'][$i]['percent'] = round(($affiliate['total_rates'] * 100) / $max_rating);

        // Top Commented
	$result = $smcFunc['db_query']('', "
	SELECT
		id_affiliate, title, comment_total
	FROM {db_prefix}affiliates
	WHERE enable = 1 AND comment_total > 0
	ORDER BY comment_total DESC LIMIT 10");
	$context['most_comments'] = array();
	$max_commenttotal = 1;
	while ($row = $smcFunc['db_fetch_assoc']($result))
	{
		$context['most_comments'][] = array(
			'title' => $row['title'],
			'comment_total' => $row['comment_total'],
			'link' => '<a href="' . $scripturl . '?action=affiliates;sa=info;id=' . $row['id_affiliate'] . '">' . $row['title'] . '</a>',
		);

		if ($max_commenttotal < $row['comment_total'])
			$max_commenttotal = $row['comment_total'];
	}
	$smcFunc['db_free_result']($result);

	foreach ($context['most_comments'] as $i => $affiliate)
		$context['most_comments'][$i]['percent'] = round(($affiliate['comment_total'] * 100) / $max_commenttotal); 

	// Last Affiliates
	$result = $smcFunc['db_query']('', "
	SELECT
		id_affiliate, title
	FROM {db_prefix}affiliates
	WHERE enable = 1
	ORDER BY id_affiliate DESC LIMIT 10");
	$context['last_upload'] = array();
	while ($row = $smcFunc['db_fetch_assoc']($result))
	{
		$context['last_upload'][] = array(			
			'title' => $row['title'],
			'link' => '<a href="' . $scripturl . '?action=affiliates;sa=info;id=' . $row['id_affiliate'] . '">' . $row['title'] . '</a>',
		);
	}
	$smcFunc['db_free_result']($result);

	// Set the template and page title
	$context['sub_template']  = 'affiliates_stats';
	$context['page_title'] = $mbname . ' - ' . $txt['affiliates_stats'];
}
?>
